<id>
Reverse Post in Topic Advanced Edition
</id>

<version>
1.1
</version>

<mod info>
With this mod Admin can choose default post-order and can allow or not the individual choice of post order. If allowed each user can change the order of the posts by clicking on the name of the topic on topic pages and/or in Profile - Options.

Feature:
- Enable/Disable Reverse Topic Summaries in Topic, so that latest post is at top
- Allow User can Reverse Posts by clicking on the name of the topic on topic page and/or set it in Profile - Options

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.  
 
/Admin/ModList.pl (ASCII)
/Admin/NewSettings.pl (ASCII)
/Admin/Settings_Main.pl (ASCII)
/Languages/English/Admin.lng (ASCII)
/Languages/English/Display.lng (ASCII)
/Languages/English/Profle.lng (ASCII)
/Sources/Display.pl (ASCII)
/Sources/Favorites.pl (ASCII)
/Sources/Load.pl (ASCII)
/Sources/MessageIndex.pl (ASCII)
/Sources/ModifyMessage.pl (ASCII)
/Sources/Post.pl (ASCII)
/Sources/Profile.pl (ASCII)
/Sources/System.pl (ASCII)

Mod History:
Status Reverse Post in Topic Advanced Edition V1.1 (June 05th  2008)
- Updated for YaBB 2.2.2

Status Reverse Post in Topic Advanced Edition V1.0 (March 25th  2008)
- First Release for YaBB 2.2.1
</mod info>

<author>
Jeffrey Man (Jet Li) and Detlef Pilzecker (deti)
</author>

<homepage>
http://www.yabbworld.com
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$reservepost = "Reserve_Post_in_Topic_Advanced_Edition|Jeffrey Man (<a href=\"http://www.yabbworld.com\" target=\"_blank\">Jet Li</a>) and Detlef Pilzecker (deti)|This mod allows a user to select if posts are displayed from oldest to newest (default) or newest to oldest in their profile preferences (If Admin enable this Option). (Global Announcements are excluded from this). No thread files are manipulated, just how a single individual views it.|1.1|June 05th, 2008";
	push (@installed_mods, "$reservepost");
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$tsreverse = $tsreverse;				# Reverse Topic Summaries (most recent becomes first)
</search for>

<replace>
\$tsreverse = $tsreverse;                                # Reverse Topic Summaries in Topic Reply (most recent becomes first)
\$ttsreverse = $ttsreverse;                        # Reverse Topic Summaries in Topic (most recent becomes first)
\$ttsureverse = $ttsureverse;                        # Reverse Topic Summaries in Topic (most recent becomes first) allowed as user wishes? Yes == 1
</replace>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			header => $cutts{'8'},
		},
		{
</search for>

<add after>
                        description => $cutts{'9'},
                        input_html => qq~<input type="checkbox" name="ttsreverse" value="1"${ischecked($ttsreverse)} />~,
                        name => 'ttsreverse',
                        validate => 'boolean',
                },
                {
                        description => $cutts{'9a'},
                        input_html => qq~<input type="checkbox" name="ttsureverse" value="1"${ischecked($ttsureverse)} />~,
                        name => 'ttsureverse',
                        validate => 'boolean',
                },
                {
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'7' => 'Reverse Topic Summaries? (So latest post is at top)',
'8' => 'Topic Summary Cutter',
</search for>

<replace>
'7' => 'Reverse Topic Summaries in Topic Reply? (So latest post is at top)',
'8' => 'Topic Summary Cutter',
'9' => 'Reverse Topic Summaries in Topic, so that latest post is at top? (Default order! See next checkbox ...)',
'9a' => 'Allow users to select the order how Topics Summaries are displayed?',
</replace>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
'alertmod_confirm' => 'Are you sure you want to alert moderator about this Message?',
</search for>

<add after>
'reverse' => 'Click here if you want to change the order topics are shown.',
</add after>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
'814' => 'Which Template would you like to use?',
</search for>

<add before>
'810' => 'Shall we reverse the displayed order of the posts in the topic?',
'811' => 'If checked the newest post of the topic will be displayed at the top of the first page. If not, the oldest post will be displayed at top of the first page and the newest at the end of the last page.<br />You can change this option by clicking at the name of the topic on the topic page.',
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	if (substr($INFO{'start'}, 0, 3) eq 'all' && $showpageall != 0) { $maxmessagedisplay = $max; $all = 1; $allselected = qq~ selected="selected"~; $start = 0; }
	else { $start = $INFO{'start'} || 0; }
	$start = $start > $mreplies ? $mreplies : $start;
	$start = (int($start / $maxmessagedisplay)) * $maxmessagedisplay;
</search for>

<replace>
	if (substr($INFO{'start'}, 0, 3) eq 'all' && $showpageall != 0) { $maxmessagedisplay = $max; $all = 1; $allselected = qq~ selected="selected"~; $start = !$ttsreverse ? 0 : $mreplies; }
	else { $start = $INFO{'start'} !~ /\d/ ? (!$ttsreverse ? 0 : $mreplies) : $INFO{'start'}  }
	$start = $start > $mreplies ? $mreplies : $start;
	$start = !$ttsreverse ? (int($start / $maxmessagedisplay) * $maxmessagedisplay) : (int(($mreplies - $start) / $maxmessagedisplay) * $maxmessagedisplay);
</replace>

<search for>
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?num=$viewnum;start=$start;action=threadpagedrop"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" style="vertical-align: middle;" /></a> $display_txt{'139'}: ~; }
			else { $pagetxtindexst .= qq~<img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $display_txt{'139'}: ~; }
			if ($startpage > 0) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/0" style="font-weight: normal;">1</a>&nbsp;<a href="javascript:void(0);" onclick="ListPages($mnum);">...</a>&nbsp;~; }
			if ($startpage == $maxmessagedisplay) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/0" style="font-weight: normal;">1</a>&nbsp;~; }
			for ($counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay) {
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?num=$viewnum/$counter" style="font-weight: normal;">$tmpa</a>&nbsp;~;
</search for>

<replace>
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?num=$viewnum;start=~ . (!$ttsreverse ? $start : $mreplies - $start) . qq~;action=threadpagedrop"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" style="vertical-align: middle;" /></a> $display_txt{'139'}: ~; }
			else { $pagetxtindexst .= qq~<img src="$imagesdir/index_togl.gif" border="0" alt="" style="vertical-align: middle;" /> $display_txt{'139'}: ~; }
			if ($startpage > 0) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/~ . (!$ttsreverse ? 0 : $mreplies) . qq~" style="font-weight: normal;">1</a>&nbsp;<a href="javascript:void(0);" onclick="ListPages($mnum);">...</a>&nbsp;~; }
			if ($startpage == $maxmessagedisplay) { $pagetxtindex = qq~<a href="$scripturl?num=$viewnum/~ . (!$ttsreverse ? 0 : $mreplies) . qq~" style="font-weight: normal;">1</a>&nbsp;~; }
			for ($counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay) {
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?num=$viewnum/~ . (!$ttsreverse ? $counter : ($mreplies - $counter)) . qq~" style="font-weight: normal;">$tmpa</a>&nbsp;~;
</replace>

<search for>
			if ($endpage != $max) { $pageindexadd .= qq~<a href="$scripturl?num=$viewnum/$lastptn" style="font-weight: normal;">$lastpn</a>~; }
</search for>

<replace>
			if ($endpage != $max) { $pageindexadd .= qq~<a href="$scripturl?num=$viewnum/~ . (!$ttsreverse ? $lastptn : $mreplies - $lastptn) . qq~" style="font-weight: normal;">$lastpn</a>~; }
</replace>

<search for>
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?num=$viewnum;start=$start;action=threadpagetext"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" /></a></span>~;
</search for>

<replace>
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?num=$viewnum;start=~ . (!$ttsreverse ? $start : $mreplies - $start) . qq~;action=threadpagetext"><img src="$imagesdir/index_togl.gif" border="0" alt="$display_txt{'19'}" /></a></span>~;
</replace>

<search for>
				$indexpage = ($i * $dropdisplaynum) * $maxmessagedisplay;
</search for>

<replace>
				$indexpage = !$ttsreverse ? ($i * $dropdisplaynum * $maxmessagedisplay) : ($mreplies - ($i * $dropdisplaynum * $maxmessagedisplay));
</replace>

<search for>
			$prevpage = $start - $tmpmaxmessagedisplay;
			$nextpage = $start + $maxmessagedisplay;
			$pagedropindexpvbl = qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			$pagedropindexnxbl = qq~<img src="$imagesdir/index_right0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			if ($start < $maxmessagedisplay) { $pagedropindexpv .= qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$prevpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/0\\'" />~; }
			if ($nextpage > $lastptn) { $pagedropindexnx .= qq~<img src="$imagesdir/index_right0.gif" border="0" height="14" width="13" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$nextpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/$lastptn\\'" />~; }
</search for>

<replace>
			$prevpage = !$ttsreverse ? $start - $tmpmaxmessagedisplay : $mreplies - $start + $tmpmaxmessagedisplay;
			$nextpage = !$ttsreverse ? $start + $maxmessagedisplay : $mreplies - $start - $maxmessagedisplay;
			$pagedropindexpvbl = qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			$pagedropindexnxbl = qq~<img src="$imagesdir/index_right0.gif" height="14" width="13" border="0" alt="" style="margin: 0px; display: inline; vertical-align: middle;" />~;
			if ((!$ttsreverse and $start < $maxmessagedisplay) or ($ttsreverse and $prevpage > $mreplies)) { $pagedropindexpv .= qq~<img src="$imagesdir/index_left0.gif" height="14" width="13" border="0" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$prevpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/~ . (!$ttsreverse ? 0 : $mreplies) . qq~\\'" />~; }
			if ((!$ttsreverse and $nextpage > $lastptn) or ($ttsreverse and $nextpage < $mreplies - $lastptn)) { $pagedropindexnx .= qq~<img src="$imagesdir/index_right0.gif" border="0" height="14" width="13" alt="" style="display: inline; vertical-align: middle;" />~; }
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?num=$viewnum/$nextpage\\'" ondblclick="location.href=\\'$scripturl?num=$viewnum/~ . (!$ttsreverse ? $lastptn : $mreplies - $lastptn) . qq~\\'" />~; }
</replace>

<search for>
			pagstart += maxpag;
</search for>

<replace>
			pagstart ~ . (!$ttsreverse ? '+' : '-') . qq~= maxpag;
</replace>

<search for>
	document.onload = SelDec('$pagejsindex', '$tstart');
</search for>

<replace>
	document.onload = SelDec('$pagejsindex', '~ . (!$ttsreverse ? $tstart : ($mreplies - $tstart)) . qq~');
</replace>

<search for>
		$notify = qq~$menusep<a href="$scripturl?action=notify;thread=$viewnum/$startnum">$img{'notify'}</a>~;
</search for>

<replace>
		$notify = qq~$menusep<a href="$scripturl?action=notify;thread=$viewnum/~ . (!$ttsreverse ? $start : $mreplies - $start) . qq~">$img{'notify'}</a>~;
</replace>

<search for>
		$template_favorite = &IsFav($viewnum, $start);
</search for>

<replace>
		$template_favorite = &IsFav($viewnum, (!$ttsreverse ? $start : $mreplies - $start));
</replace>

<search for>
	if (!$UseMenuType) { $sm = 1; }
	$counter = 0;
	$avacounter = 0;
</search for>

<replace>
	if (!$UseMenuType) { $sm = 1; }
	$counter = 0;
</replace>

<search for>
	while ($counter < $start && ($buffer = <MSGTXT>)) { $counter++; }

	$#messages = $maxmessagedisplay - 1;
	for ($counter = 0; $counter < $maxmessagedisplay && ($buffer = <MSGTXT>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(MSGTXT);
	$#messages = $counter - 1;
	$counter = $start;
</search for>

<replace>
	if (!$ttsreverse) {
	    while ($buffer = <MSGTXT>) {
	        if ($counter >= $start and $counter < ($start + $maxmessagedisplay)) { push(@messages, $buffer); }
	        $counter++;
             }
             $counter = $start;

	} else {
	    while ($buffer = <MSGTXT>) {
	        if ($counter > ($mreplies - $start - $maxmessagedisplay) and $counter <= ($mreplies - $start)) { push(@messages, $buffer); }
	        $counter++;
	}
 	$counter = $mreplies - $start;
	@messages = reverse(@messages);
	}

	fclose(MSGTXT);
</replace>

<search for>
				</noscript>
				~;
					}
					$avacounter++;
</search for>

<replace>
				</noscript>
				~;
					}
</replace>

<search for>
		if ($counter != 0) { $counterwords = "$display_txt{'146'} #$counter - "; }
</search for>

<replace>
		if ($counter != 0) { $counterwords = "$display_txt{'146'} #$counter - "; } else { $counterwords = ""; }
</replace>

<search for>
		$counter++;
</search for>

<replace>
		$counter += !$ttsreverse ? 1 : -1;
</replace>

<search for>
	$yynavigation = qq~&rsaquo; $template_cat &rsaquo; $template_board &rsaquo; $curthreadurl~;
</search for>

<add after>
	# Create link to modify displayed post order if allowed
	$curthreadurl = qq~<a title="$display_txt{'reverse'}" href="$scripturl?num=$viewnum;start=~ . (!$ttsreverse ? $mreplies : 0) . qq~;action=~ . ($userthreadpage == 1 ? 'threadpagetext' : 'threadpagedrop') . qq~;reversetopic=$ttsreverse">$curthreadurl</a>~ if (!$iamguest and $ttsureverse);
</add after>

<search for>
	$formstart .= qq~<form name="multidel" action="$scripturl?board=$currentboard;action=multidel;thread=$viewnum/$start" method="post" style="display: inline">~;
</search for>

<replace>
	$formstart .= qq~<form name="multidel" action="$scripturl?board=$currentboard;action=multidel;thread=$viewnum/~ . (!$ttsreverse ? $start : $mreplies - $start) . qq~" method="post" style="display: inline">~;
</replace>

<search for>
		for (var i = $start; i < $counter; i++) {
	 		if(i == counter) { document.forms["multidel"].elements["del"+i].checked = true; }
			else { document.forms["multidel"].elements["del"+i].checked = false; }
		}
</search for>

<replace>
		for (var i = 0; i < document.forms["multidel"].length; ++i) {
	 		if (document.forms["multidel"].elements[i].type == "checkbox") document.forms["multidel"].elements[i].checked = false;
		}
		document.forms["multidel"].elements["del"+counter].checked = true;
</replace>

<search for>
	if ($INFO{'action'} eq "threadpagetext") {
		${$uid.$username}{'pageindex'} = qq~$msindx|1|$mbindx|$pmindx~;
	}
</search for>

<add after>
	if (exists($INFO{'reversetopic'})) {
	    ${$uid.$username}{'reversetopic'} = $INFO{'reversetopic'} ? '' : 1;
	}
</add after>

<edit file>
Sources/Favorites.pl
</edit file>

<search for>
			$pages = qq~ <a href="$scripturl?num=$mnum/0#0">1</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$maxmessagedisplay#$maxmessagedisplay">2</a>~;
</search for>

<replace>
			$pages = qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "0#0" : "$mreplies#$mreplies") . qq~">1</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$maxmessagedisplay#$maxmessagedisplay" : ($mreplies - $maxmessagedisplay) . '#' . ($mreplies - $maxmessagedisplay)) . qq~">2</a>~;
</replace>

<search for>
			$pages .= qq~ <a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$j#$j">$k</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$i#$i">$endpage</a>~;
</search for>

<replace>
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$tmpb#$tmpb" : ($mreplies - $tmpb) . '#' . ($mreplies - $tmpb)) . qq~">$tmpa</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$j#$j" : ($mreplies - $j) . '#' . ($mreplies - $j)) . qq~">$k</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$i#$i" : ($mreplies - $i) . '#' . ($mreplies - $i)) . qq~">$endpage</a>~;
</replace>

<search for>
				$pages .= qq~<a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>\n~;
</search for>

<replace>
				$pages .= qq~<a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$tmpb#$tmpb" : ($mreplies - $tmpb)) . qq~">$tmpa</a>\n~;
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
			&CalcAge($username, "calc");
</search for>

<add after>
			# Set the order how Topic summaries are displayed
			$ttsreverse = ${$uid.$username}{'reversetopic'} if !$adminscreen && $ttsureverse;
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
			$pages = qq~ <a href="$scripturl?num=$mnum/0#0">1</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$maxmessagedisplay#$maxmessagedisplay">2</a>~;
			$endpage = int($mreplies / $maxmessagedisplay) + 1;
			$i = ($endpage - 1) * $maxmessagedisplay;
			$j = $i - $maxmessagedisplay;
			$k = $endpage - 1;
			$tmpa = $endpage - 2;
			$tmpb = $j - $maxmessagedisplay;
			$pages .= qq~ <a href="javascript:void(0);" onclick="ListPages($mnum);">...</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$j#$j">$k</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/$i#$i">$endpage</a>~;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages $pagesall &#187;</span>~;
		} elsif ($mreplies + 1 > $maxmessagedisplay) {
			$tmpa = 1;
			for ($tmpb = 0; $tmpb < $mreplies + 1; $tmpb += $maxmessagedisplay) {
				$pages .= qq~<a href="$scripturl?num=$mnum/$tmpb#$tmpb">$tmpa</a>\n~;
</search for>

<replace>
			$pages = qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "0#0" : "$mreplies#$mreplies") . qq~">1</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$maxmessagedisplay#$maxmessagedisplay" : ($mreplies - $maxmessagedisplay) . '#' . ($mreplies - $maxmessagedisplay)) . qq~">2</a>~;
			$endpage = int($mreplies / $maxmessagedisplay) + 1;
			$i = ($endpage - 1) * $maxmessagedisplay;
			$j = $i - $maxmessagedisplay;
			$k = $endpage - 1;
			$tmpa = $endpage - 2;
			$tmpb = $j - $maxmessagedisplay;
			$pages .= qq~ <a href="javascript:void(0);" onclick="ListPages($mnum);">...</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$tmpb#$tmpb" : ($mreplies - $tmpb) . '#' . ($mreplies - $tmpb)) . qq~">$tmpa</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$j#$j" : ($mreplies - $j) . '#' . ($mreplies - $j)) . qq~">$k</a>~;
			$pages .= qq~ <a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$i#$i" : ($mreplies - $i) . '#' . ($mreplies - $i)) . qq~">$endpage</a>~;
			$pages = qq~<br /><span class="small">&#171; $messageindex_txt{'139'} $pages $pagesall &#187;</span>~;
		} elsif ($mreplies + 1 > $maxmessagedisplay) {
			$tmpa = 1;
			for ($tmpb = 0; $tmpb < $mreplies + 1; $tmpb += $maxmessagedisplay) {
				$pages .= qq~<a href="$scripturl?num=$mnum/~ . (!$ttsreverse ? "$tmpb#$tmpb" : ($mreplies - $tmpb) . '#' . ($mreplies - $tmpb)) . qq~">$tmpa</a>\n~;
</replace>

<search for>
		$pages .= qq~<a href='javascript: opp_page("$tlink","$tmpb");'>$tmpa</a>\n~;
</search for>

<replace>
		$pages .= qq~<a href='javascript: opp_page("$tlink","~ . ((!$ttsreverse or $INFO{'board'}) ? $tmpb : (${$INFO{'num'}}{'replies'} - $tmpb)) . qq~");'>$tmpa</a>\n~;
</replace>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	my $start = int($postid / $maxmessagedisplay) * $maxmessagedisplay;
</search for>

<replace>
	my $start = !$ttsreverse ? (int($postid / $maxmessagedisplay) * $maxmessagedisplay) : $treplies - (int(($treplies - $postid) / $maxmessagedisplay) * $maxmessagedisplay);
</replace>

<search for>
			if ($message[12] ne "") { &remove_att($message[12]); }
			splice(@messages, $count, 1);
			$kill++;
</search for>

<add after>
			$yySetLocation = qq~$scripturl?num=$thread/$count~ if !$ttsreverse or $kill == 1;
</add after>

<search for>
		my $start = int($postid / $maxmessagedisplay) * $maxmessagedisplay;
</search for>

<replace>
		my $start = !$ttsreverse ? (int($postid / $maxmessagedisplay) * $maxmessagedisplay) : ${$thread}{'replies'} - (int((${$thread}{'replies'} - $postid) / $maxmessagedisplay) * $maxmessagedisplay);
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
			$quotestart = int($quotemsg / $maxmessagedisplay) * $maxmessagedisplay;
			my $maxlengthofquote = $MaxMessLen - length(qq~[quote author=$hidename link=$threadid/$quotestart#$quotemsg date=$mdate\]\[/quote\]\n~) - 3;
</search for>

<replace>
			my $maxlengthofquote = $MaxMessLen - length(qq~[quote author=$hidename link=$threadid/$quotemsg#$quotemsg date=$mdate\]\[/quote\]\n~) - 3;
</replace>

<search for>
			$message    = qq~[quote author=$hidename link=$threadid/$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
</search for>

<replace>
			$message    = qq~[quote author=$hidename link=$threadid/$quotemsg#$quotemsg date=$mdate\]$message\[/quote\]\n~;
</replace>

<search for>
	# this defines if the notify on reply is shown or not.
	if ($iamguest || $destination eq "modalert2" ||$destination eq "guestpm2") {
		$notification = '';
	} else {
</search for>

<add after>
		$notify = qq~ checked="checked"~ if $FORM{'notify'} eq 'x';
</add after>

<search for>
	# Let's figure out what page number to show
	$start     = 0;
</search for>

<replace>
	# Let's figure out what page number to show
</replace>

<search for>
	$start = $mreplies;
	#&template;
	#&exit;
	&redirectexit;
}
</search for>

<replace>
	#&template;
	#&exit;
	&redirectexit;
}
</replace>

<search for>
			$quotestart = int($quotemsg / $maxmessagedisplay) * $maxmessagedisplay;
			my $maxlengthofquote = $MaxMessLen - length(qq~[quote author=$hidename link=$threadid/$quotestart#$quotemsg date=$mdate\]\[/quote\]\n~) - 3;
</search for>

<replace>
			my $maxlengthofquote = $MaxMessLen - length(qq~[quote author=$hidename link=$threadid/$quotemsg#$quotemsg date=$mdate\]\[/quote\]\n~) - 3;
</replace>

<search for>
			$message    = qq~[quote author=$hidename link=$threadid/$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
</search for>

<replace>
			$message    = qq~[quote author=$hidename link=$threadid/$quotemsg#$quotemsg date=$mdate\]$message\[/quote\]\n~;
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
	$showProfile .= qq~<tr class="windowbg">
          <td align="left"><b>$profile_txt{'814'}</b><br /><span class="small">$profile_txt{'815'}</span></td>
          <td align="left"><select name="usertemplate">$drawndirs</select></td>
        </tr>~;
</search for>

<add after>
	if ($ttsureverse) {
	    ${$uid.$user}{'reversetopic'} = $ttsreverse unless exists(${$uid.$user}{'reversetopic'});
	    $showProfile .= qq~<tr class="windowbg">
	    <td align="left"><b>$profile_txt{'810'}</b><br /><span class="small">$profile_txt{'811'}</span></td>
	    <td align="left" valign="top"><input type="checkbox" name="reversetopic"~ . (${$uid.$user}{'reversetopic'} ? qq~ checked="checked"~ : '') . qq~ /></td>
	    </tr>~;
	}
</add after>

<search for>
		${$uid.$user}{'template'} = $member{'usertemplate'};
</search for>

<add after>
		${$uid.$user}{'reversetopic'} = $member{'reversetopic'};
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
		$userext = "vars";
</search for>

<add after>
		${$uid.$user}{'reversetopic'} = $ttsreverse unless exists(${$uid.$user}{'reversetopic'});
</add after>

<search for>
	my @tags = qw(password realname email regdate regreason webtitle weburl spamcount spamtime signature postcount position addgroups icq aim yim skype gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex lastips onlinealert pmactprev pmmessprev pmviewMess buddylist offlinestatus awaysubj awayreply awayreplysent stealth);
</search for>

<replace>
	my @tags = qw(password realname email regdate regreason webtitle weburl spamcount spamtime signature postcount position addgroups icq aim yim skype gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex lastips onlinealert pmactprev pmmessprev pmviewMess buddylist offlinestatus awaysubj awayreply awayreplysent stealth reversetopic);
</replace>